﻿
namespace ProjectStormTrooper.Entities
{
    public class EntityWarPlane
    {

        /// <summary>
        /// Скорость
        /// </summary>

        public int Speed { get; private set; }
        /// <summary>
        /// Вес
        /// </summary>

        public double Weight { get; private set; }
        /// <summary>
        /// Основной цвет
        /// </summary>

        public Color BodyColor { get; private set; }
        /// <summary>
        /// цвет головы
        /// </summary>
        public Color ColorOfHead { get; private set; }
        public void SetBodyColor(Color bodyColor)
        {
            BodyColor = bodyColor;
        }
        public void SetColorOfHead(Color colorOfHead)
        {
            ColorOfHead = colorOfHead;
        }
        /// <summary>
        /// Шаг перемещения штурмовика
        /// </summary>

        public double Step => Speed * 200 / Weight;
        public EntityWarPlane(int speed, double weight, Color bodyColor, Color colorOfHead) {
            Speed = speed;
            Weight = weight;
            BodyColor = bodyColor;
            ColorOfHead = colorOfHead;

        }
        //TODO Прописать метод

        /// <summary>
        /// Получение строк со значениями свойств объекта класса-сущности
        /// </summary>
        /// <returns></returns>
        public virtual string[] GetStringRepresentation()
        {
            return new[] { nameof(EntityWarPlane), Speed.ToString(), Weight.ToString(), BodyColor.Name, ColorOfHead.Name};
        }

        /// <summary>
        /// Создание объекта из массива строк
        /// </summary>
        /// <param name="strs"></param>
        /// <returns></returns>
        public static EntityWarPlane? CreateEntityCar(string[] strs)
        {
            if (strs.Length != 5 || strs[0] != nameof(EntityWarPlane))
            {
                return null;
            }

            return new EntityWarPlane(Convert.ToInt32(strs[1]), Convert.ToDouble(strs[2]), Color.FromName(strs[3]), Color.FromName(strs[4]));
        }

    }
}
