using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.DependencyInjection;
using Serilog;
namespace ProjectStormTrooper
{
	internal static class Program
	{

		[STAThread]
        /// <summary>
        ///  The main entry point for the application.
        /// </summary>

        static void Main()
		{

			ApplicationConfiguration.Initialize();
            ServiceCollection services = new();
            ConfigureServices(services);
            using ServiceProvider serviceProvider =
            services.BuildServiceProvider();
            Application.Run(serviceProvider.GetRequiredService<FormWarPlaneCollection>());        
        }
        /// <summary>
        ///   DI
        /// </summary>
        /// <param name="services"></param>
        private static void ConfigureServices(ServiceCollection services)
        {
            services.AddSingleton<FormWarPlaneCollection>()
                    .AddLogging(option =>
                    {
                        var configuration = new ConfigurationBuilder()
                            .SetBasePath(Directory.GetCurrentDirectory())
                            .AddJsonFile(path: "appsettings.json", optional: false, reloadOnChange: true)
                            .Build();

                        var logger = new LoggerConfiguration()
                            .ReadFrom.Configuration(configuration)
                            .CreateLogger();

                        option.SetMinimumLevel(LogLevel.Information);
                        option.AddSerilog(logger);

                    });
        }
    }
}
